#!/usr/bin/env python3

# Copyright 2018 Intel Corporation.
# The source code, information and material ("Material") contained herein is
# owned by Intel Corporation or its suppliers or licensors, and title to such
# Material remains with Intel Corporation or its suppliers or licensors.
# The Material contains proprietary information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright laws and treaty
# provisions.
# No part of the Material may be used, copied, reproduced, modified, published,
# uploaded, posted, transmitted, distributed or disclosed in any way without
# Intel's prior express written permission. No license under any patent,
# copyright or other intellectual property rights in the Material is granted to
# or conferred upon you, either expressly, by implication, inducement, estoppel
# or otherwise.
# Any license under such intellectual property rights must be express and
# approved by Intel in writing.

from Controllers.Parsers.TensorFlowParser.Helpers import getInputNames, getOutputNames, findTensorValue
from Controllers.Parsers.Parser.Scale import Scale
import numpy as np

def load(obj, operations):
    assert(len(obj.inputs) == 2)
    assert(len(obj.outputs) == 1)

    inp = obj.inputs[0]

    x = Scale(obj.name, [inp.name], getOutputNames(obj))

    divisor = obj.inputs[1]
    value = findTensorValue(divisor.name, operations)

    beta_zero = np.zeros(value.shape)
    x.assignMultiplier(1/value)
    x.assignBiasBeta(beta_zero)

    return [x]